/********************************************************************
 *  Nomes: Gabriel Capella                       Números USP: 8962078 
 *         João Herique Luciano                               8535957
 * 
 *  Tarefa:    RedCore - EP2 MAC0463
 *  Arquivo:   params.h
 *  Descrição: Definições de parâmetros usados no jogo
 ********************************************************************/

#ifndef params_h
#define params_h

// BALL
#define BALL_SIZE 15
#define THROW_ANG 20 // in degrees
#define INITIAL_SPEED 500

// TAMANHO DO NUCLEO
#define CORE_RADIUS 50

// PADDLE
#define PADDLE_WIDTH 120
#define PADDLE_HEIGHT 10
#define PADDLE_ALTURA 90

// CORES
#define COLOR_back Color4B(39, 40, 34, 255)
#define COLOR_pink Color4B(249,38,114, 255)
#define COLOR_blue Color4B(102,217,239, 255)
#define COLOR_green Color4B(166,226,46, 255)
#define COLOR_orange Color4B(253,151,31, 255)
#define COLOR_grey Color4B(120,120,120, 255)
#define COLOR_red Color4F(0.988, 0.147, 0.030, 1)

// TAGs
#define BALL_TAG 15
#define BLOCK_TAG 10
#define CORE_TAG 11
#define BOTTOM_TAG 12
#define INDESTRUCTIBLE_BLOCK_TAG 13
#define PADDLE_TAG 14

#define THREE_BALLS_TAG 9
#define SAVE_TAG 8
#define PADDLE_BALL_TAG 7
#define SUPERBALL_TAG 6

// Probabilities
#define DROP_LEVEL_SAVE 0.03
#define DROP_TRIPLE_BALL 0.06 // Aumenta com o tempo
#define DROP_PADDLE_BALL 0.05
#define DROP_SUPER_BALL 0.03

// Power Ups Seconds Interval
#define POWER_UP_INTERVAL 2.5

// Time to paddle back to normal size
#define POWER_UP_PADDLE_SECONDS 10

// Hours to lose level
#define LOSE_IS 12

// FONT
#define FONT "fonts/abel.ttf"

// TEXT
#define MSG_TRIPE_BALLS "Triple Balls!"
#define MSG_LEVEL_SAVED "Level Saved!"
#define MSG_TITLE "RedCore"
#define MSG_OVER "Game Over..."
#define MSG_DOUBLE_PADDLE "Doubled paddle!"
#define MSG_HALF_PADDLE "Half paddle :("
#define MSG_LEVEL_BACK "You are at level %d. In %.1f hour(s) you will regrow a level."
#define MSG_NEXT_LEVEL "Next Level"
#define MSG_RESTART "Restart"
#define MSG_SUPER_BALL "Super Ball!"
#define MSG_START "Start"

// DEBUG
#define DEBUG 0

#endif /* params_h */
